All Classes and Interfaces
Class
Description
Abstract
BroadcasterCache which is used to implement headers, query parameters or
session based caching.Abstract
Broadcaster that delegates the internal processing to a proxy.Simple
AtmosphereHandler that reflect every call to
Broadcaster.broadcast(java.lang.Object), eg sent the broadcasted event back to the remote client.
This default implementation does nothing when
AbstractReflectorAtmosphereHandler.Default.onRequest(org.atmosphere.cpr.AtmosphereResource) is called.An Action is used by
AtmosphereInterceptor, AsyncSupport and AtmosphereFramework to determine
what to do with a request, e.g suspend it, resume it, etc.The action's type.
A marker interface that does nothing except used by
AtmosphereInterceptor to modify the default
behavior of any functionality.Fix for the Android 2.2.x bogus HTTP implementation.
Shared lifecycle and injection support for annotated endpoint classes.
Marker class for an
AtmosphereHandler proxy of a POJO object.AnnotationDetector reads Java Class File (".class") files and reports the
encountered annotations via a simple, developer friendly API.A
Reporter for field annotations.A
Reporter for method annotations.Reporter is the base interface, used to report the detected annotations.A
Reporter for type annotations.A class that handles the results of an annotation scan.
An annotation processor for configuring the
AtmosphereFramework.A ServletContainerInitializer that scans for annotations, and places them in a map keyed by annotation type in the
servlet context.
Web.xml init-param configuration supported by Atmosphere.
An annotation for
Injectable used to decide when the injection must happens.Base class which implement the semantics of suspending and resuming of a Comet/WebSocket Request.
A filter-like API that allow an
AtmosphereInterceptor to intercept the response before it gets written back
to the client.An Adapter for
AsyncIOInterceptor.An Asynchronous I/O Writer is used by a
AtmosphereResponse when writing data.Adapter class for
AsyncIOWriter.Atmosphere's supported WebServer must implement this interface in order to be auto detected by the
AtmosphereFramework.A listener that can be used to track
AsyncSupport events like SUSPEND, RESUME, TIMEOUT, DESTROYED and CLOSEDA default implementation of
AsyncSupportListenerAn annotation for telling Atmosphere which
AsyncSupportListener class to use by default.This interface is used by
AtmosphereFramework to determine which AsyncSupport instance should be usedAn annotation for telling Atmosphere which
AsyncSupport class to use by default.This annotation is scanned by Atmosphere at runtime to determine
Processor implementation.Single source of truth for all Atmosphere annotation types and their processor mappings.
This class contains information about the current state of the
AtmosphereFramework.A shutdown hook that will be called when the
AtmosphereFramework.destroy() method gets invoked.A Startup hook that will be called when the
AtmosphereFramework.init() method complete.Descriptor for an Atmosphere configuraton file.
Atmosphere has support for
Filters, delegating all work to AtmosphereServlet.Implementation of
jakarta.servlet.FilterChain used to manage
the execution of a set of filters for a particular request.The
AtmosphereFramework is the entry point for the framework.Lifecycle listener for
AtmosphereFrameworkAdapter for
AtmosphereFrameworkListenerAn annotation for installing
AtmosphereFrameworkListenerImplementation of
AtmosphereHandler allows creation of event-driven web applications which are hosted in
the browser.An implementation of
AtmosphereHandler that does nothing.An annotation for
AtmosphereHandlerHandle
Singleton and
AtmosphereHandlerService processing.Wrapper around an
AtmosphereHandler and its associated Broadcaster,
mapping path, and interceptor chain.Framework-level health check for Atmosphere.
Intercept the dispatch of
AtmosphereResource before they get dispatched to AtmosphereHandlers.A Simple
AtmosphereInterceptor that creates an AtmosphereInterceptorWriter and sets it as
the default AsyncIOWriter on an AtmosphereResponse.An annotation for telling Atmosphere which
AtmosphereInterceptor class to use by default.An
AsyncIOWriter that delegates the write operation to its AsyncIOInterceptor.Thrown when
AsynchronousProcessor is unable to map the request to an AtmosphereHandler.Micrometer metrics integration for Atmosphere.
Customization point for Atmosphere to instantiate classes.
Atmosphere Internal Object Injection for DI supporting JSR 330
Single source of truth for all Atmosphere types that require reflective access
at runtime (GraalVM native image, Spring AOT, Quarkus native build).
An Atmosphere request representation.
An Atmosphere request representation.
Deprecated.
AtmosphereRequest injection support.An
AtmosphereResource encapsulates the mechanism to AtmosphereResource.suspend(), AtmosphereResource.resume() and
broadcast (AtmosphereResource.getBroadcaster()) messages among suspended resources.An AtmosphereResourceEvent is created every time an event occurs, like when a
Broadcaster.broadcast(java.lang.Object) is executed, when a browser remotely closes the connection or
when a suspended resource times out or gets resumed.AtmosphereResourceEvent implementation.invalid input: '{@link /*missing*/}'AtmosphereResource} injection implementation support.
Receive notifications when resume, client disconnect or broadcast events occur.
An implementation of
AtmosphereResourceEventListener which just log events with log level TRACE.On Broadcast's Listener
On Close's Listener
On Disconnect's Listener
On Heartbeat's Listener
On PreSuspend's Listener
On Resume's Listener
On Suspend's Listener
On Throwable's Listener
A Factory used to manage
AtmosphereResource instances.An interface to use in order to retrieve an
AtmosphereResource inside a cluster.An annotation for telling Atmosphere which
AtmosphereResourceFactory class to use by default.Receive notifications when heartbeat events occur.
Explicit lifecycle states for an
AtmosphereResource, replacing the previous
collection of independent AtomicBoolean fields that tracked lifecycle implicitly.AtmosphereResource injection using ScopedValues (JDK 21+).This
AtmosphereInterceptor implementation automatically suspends the intercepted
AtmosphereResource and takes care of managing the response's state (flushing, resuming,
etc.) when a Broadcaster.broadcast(java.lang.Object) is invoked.Listener for when
AtmosphereResource gets suspended and disconnected.Adapter for
AtmosphereResourceListenerInstall an
AtmosphereResourceListenerThe AtmosphereResourceSession is managed by the
AtmosphereResourceSessionFactory.Factory for
AtmosphereResourceSession instancesThis interceptor associates a
AtmosphereResource to all Broadcaster the resource was added before
the underlying connection got closed and resume.An Atmosphere's response representation.
An Atmosphere's response representation.
AtmosphereResponse injection using ScopedValues (JDK 21+).An annotation which acts like the
ManagedService annotated resource, but
that can be used with frameworks like Jersey, Wicket or any framework running the Atmosphere Framework.AtmosphereServlet that use Servlet 3.0 Async API when available, and fallback to native comet support if not available.
Simple interface that can be used to wrap a
Servlet from an AtmosphereHandler.An AtmosphereSession allow an application to keep track of the AtmosphereResource associated with a remote client.
OpenTelemetry tracing interceptor for Atmosphere requests.
Authentication interceptor that validates tokens on every inbound request.
Backpressure interceptor that tracks per-client pending message counts
and applies configurable policies when a client falls behind.
Backpressure drop policy.
This class is used when the
AtmosphereFramework fails to autodetect
the Servlet Container we are running on.An Bounder Broadcaster Pool Provider of
Broadcaster.A bounded, in-memory
BroadcasterCache that stores recent broadcast
messages per client UUID.A Broadcaster is responsible for delivering messages to its subscribed
AtmosphereResources, which are
representing suspended responses.A BroadcasterCache is a cache for broadcasted messages.
Inspect
BroadcastMessages before they get added to the BroadcasterCache.Annotation used to mark a
BroadcasterCacheInspector.Listener for
BroadcasterCacheAn annotation for installing
BroadcasterListenerAn annotation for telling Atmosphere which
BroadcasterCache class to use by default.Manipulate the message before and after they are getting filtered by
BroadcastFilterFactory for
Broadcaster used by Atmosphere when creating broadcasters.An annotation for telling Atmosphere which
BroadcasterFactory class to use by default.An annotation for telling Atmosphere to add the
BroadcastFilter to all created BroadcasterSimple
Future that can be used when awaiting for a Broadcaster to finish
its broadcast operation to AtmosphereHandler.Broadcaster and Named injection support.Encapsulates the lifecycle management concern for a
DefaultBroadcaster.This class can be used to configure the life cycle of a
Broadcaster, eg.Simple listener to be used to track
BroadcasterLifeCyclePolicy events.Simple adapter listener to be used to track
BroadcasterLifeCyclePolicy events.A listener for a
Broadcaster's event lifecycle.Throw this exception to interrupt the
Broadcaster.destroy() operation.An implementation of
BroadcasterListener.An annotation for installing
BroadcasterListenerEncapsulates the resource membership concern for a
DefaultBroadcaster.An annotation for telling Atmosphere which
Broadcaster class to use by default.Encapsulates broadcaster-related configuration and state for the Atmosphere framework.
Transform a message before it get broadcasted to
AtmosphereHandler.onStateChange(org.atmosphere.cpr.AtmosphereResourceEvent).Simple class that tells the
Broadcaster to broadcast or not the transformed value.Adapter for
PerRequestBroadcastFilter.Add lifecycle method to the
BroadcastFilter interface.A wrapper around an object passed to
Broadcaster.broadcast(Object)This read the request's body and invoke the associated
Broadcaster of an AtmosphereResource.An
AsyncIOWriter backed by an ByteArrayOutputStreamAt interceptor for customizing the following headers: Expire, Cache-Control, Pragma,
Access-Control-Origin and Access-Control-Allow-Credential.
A simple marker interface for for the CDI extension.
Creates a signle reader instance from a sequence of readers.
Encapsulates classpath scanning configuration and state for the Atmosphere framework.
Specialize
BroadcastFilter used when clustering is enabled.The CompletionAware interface is used by a class implementing the
AtmosphereResponse interface
to be notified when writing to the response has been completed.Initializer for the AtmosphereFramework per servlet instance,
this initializer is called during web-application startup lifecycle (since Servlet 3.0).
This class is a cut invalid input: '&' paste from Tomcat's Cookie creation.
CORS support.
Decode a message in order to invoke a class annotated with
ManagedService with a method
annotated with Message.An
AnnotationProcessor that selects between a ServletContextInitializer based scanner, and
a bytecode based scanner based on .This is the default implementation of @link {AsyncSupportResolver}.
Default
AtmosphereObjectFactory implementation that creates instances
using the default no-arg constructor via reflection.A Factory used to manage
AtmosphereResource instances.The default
Broadcaster implementation.This class is responsible for creating
Broadcaster instances.Default implementation of the
EndpointMapper used by the AsynchronousProcessor
and DefaultWebSocketProcessorBroadcast events to all or a subset of available
Broadcasters based on their Broadcaster.getID() value.Default
Room implementation backed by a Broadcaster.Like the
AsynchronousProcessor class, this class is responsible for dispatching WebSocket request to the
proper WebSocket implementation.Use this annotation with the
ManagedService annotation.A Deliver is an
Broadcaster's internal token that is created before the message gets Broadcaster.Broadcast the returned value only to the calling resource
DeliverTo.DELIVER_TO.RESOURCE,
to its associated Broadcaster DeliverTo.DELIVER_TO.BROADCASTER
or to all created Broadcasters DeliverTo.DELIVER_TO.ALLUse this annotation with the
ManagedService annotation.Simple
WebSocketProcessor that invoke the Broadcaster.broadcast(java.lang.Object) API when a WebSocket message
is received.websocketd support.
Encode a message returned by a method annotated with
Message or a ManagedService
annotated class.This class is responsible for mapping request to handler like
AtmosphereHandler
or WebSocketHandlerAn annotation to use in order to replace the default
EndpointMapperAn implementation of
DefaultBroadcaster that exclude one or more AtmosphereResourceFactory to create
ExecutorService for Atmosphere components.FileIterator enables iteration over all files in a directory and all
its sub directories.FilterConfig implementation.Request attribute a framework integrator can use to lookup Atmosphere internal objects.
Manages listener registration and event dispatch for the Atmosphere framework.
Use this annotation with the
ManagedService annotation.Manages
AtmosphereHandler registration, mapping, and lifecycle.This interface contains all Atmosphere headers shared between the client and the server.
Annotate a method that will get invoked when the client sends an heartbeat.
Specifies to the observable that
AtmosphereResourceHeartbeatEventListener.onHeartbeat(org.atmosphere.cpr.AtmosphereResourceEvent)
should be invoked when it fires event to observers.
An interceptor that send whitespace every in 60 seconds by default.
Utility class for encoding strings to prevent HTML injection (XSS).
An Interceptor that track idle
AtmosphereResource and close it.An Injectable class allow the
InjectableObjectFactory to assign a value to a field annotated with the
Inject annotation.Support injection of Atmosphere's Internal object using
AtmosphereConfig,AtmosphereFramework,
invalid @link
{@link org.atmosphere.cpr.BroadcasterFactory,
AtmosphereResourceFactory ,DefaultMetaBroadcaster and
AtmosphereResourceSessionFactory and classes implementing the Injectable defined inside
META_INF/services/org.atmosphere.inject.InjectAn Injectable class allow the
InjectableObjectFactory to inspect fields and methods before they get injected or executed.Adapter class for
InjectIntrospectorFileIterator enables iteration over all files in a directory and all
its sub directories.Manages
AtmosphereInterceptor registration, configuration, and lifecycle.Utils for introspection and reflection
A simple marker class to use with
AtmosphereInterceptor in order to determine in which
position in the interceptor's chain the AtmosphereInterceptor must be installed.
An Interceptor that sends back to a websocket and http client the value of
HeaderConfig.X_ATMOSPHERE_TRACKING_ID.Asynchronous based
Session websocketThe KeepOpenStreamAware interface is used by a class implementing the
AsyncIOWriter interface
to indicate the closing of the underlining stream is managed elsewhere and invoking the
AsyncIOWriter.close(AtmosphereResponse) method does not close the stream.An internal implementation of
AtmosphereHandler that implement support for Atmosphere 2.0 annotations.Deprecated, for removal: This API element is subject to removal in a future version.
Use
RawMessage instead.A Meta annotation that configure Atmosphere with
The
UUIDBroadcasterCachefor caching message.Handle
Singleton for ManagedService processing.Interceptor that populates the SLF4J
MDC with Atmosphere-specific
context for structured logging.Annotate a method that will get invoked when String messages are broadcasted using the
Broadcaster
associated with the class where the annotation is associated.Interceptor that implements message acknowledgment for reliable delivery.
Broadcast events to all or a subset of available
Broadcasters based on their Broadcaster.getID() value.Cache message if no
Broadcaster maps the MetaBroadcaster.broadcastTo(String, Object)Flush the cache every 30 seconds.
This enumeration represents all possible actions to specify in a meta service file.
Add proper header for Nginx's buffering http://wiki.nginx.org/HttpProxyModule#proxy_buffering
This interceptor set the 'X-Accel-Buffering : No' on the
This interceptor set the 'X-Accel-Buffering : No' on the
AtmosphereResponse before it gets suspended.A no-op
HttpServletRequest implementation used as a default when no real request is available.Old 8k Padding interceptor for Browser that needs whitespace when streaming is used.
When the browser close the connection, the atmosphere.js will send an unsubscribe message to tell
framework the browser is disconnecting.
Simple
AtmosphereHandler that must be used with the AtmosphereResourceLifecycleInterceptor
and BroadcastOnPostAtmosphereInterceptor to reduce the handling of the suspend/resume/disconnect and
broadcast operation.Padding interceptor for Browser that needs whitespace when streaming is used.
Use this annotation with the
ManagedService annotation.PathParam injection support.A lightweight URI path template that supports
{varName} and
{varName:regex} syntax.An extended
BroadcastFilter that can be used to filter based on AtmosphereResource.This class uses a
PoolableProvider to retrieve instance of Broadcaster.Implements this interface for provisioning the
PoolableBroadcasterFactory
with BroadcasterUse this annotation with the
ManagedService annotation.PostConstruct implementation support.
Event fired when a member joins or leaves a
Room.Class annotated with
AtmosphereAnnotation must implement this interface in order to get invoked
when the AtmosphereFramework.init() executes.Use this annotation with the
ManagedService annotation.Splits an HTTP query string into a path string and key-value parameter pairs.
Inbound rate-limiting interceptor using a token-bucket algorithm.
Rate limit exceeded policy.
A wrapper that marks a message as already-encoded ("raw"), signaling the
framework to deliver it as-is without running it through
@Message
decoders and encoders in AtmosphereHandler.onStateChange(org.atmosphere.cpr.AtmosphereResourceEvent).InputStream implementation that reads a character stream from a Reader
and transforms it to a byte stream using a specified charset encoding.Use this annotation with the
ManagedService annotation.Deprecated.
An implementation of
AtmosphereHandler using the AtmosphereServletProcessor that delegate the AtmosphereHandler.onRequest(org.atmosphere.cpr.AtmosphereResource)
to a set of FilterChain and Servlet.service(jakarta.servlet.ServletRequest, jakarta.servlet.ServletResponse)
and store the AtmosphereResource as a AtmosphereRequestImpl.getAttribute(String) attribute named
FrameworkConfig.ATMOSPHERE_RESOURCE.An annotation for
InjectIntrospector used to decide when the injection must happens.Use this annotation with the
ManagedService annotation.A named group of
AtmosphereResource connections.Actions that can be performed on a
Room.Annotation for
AtmosphereHandler classes to
declare authorization requirements for room operations.Authorizes room operations.
Interceptor that auto-joins resources to rooms based on URL path.
Manages the lifecycle of
Room instances.Application-level identity for a room member.
JSON encoder/decoder for the room protocol, using
org.json
(already a dependency of atmosphere-runtime via SimpleRestInterceptor).Bridges the atmosphere.js client room protocol to the server-side
Room API.Protocol messages exchanged between clients and the server for
room operations.
Broadcast a message to all room members.
Send a direct message to a specific member by member ID.
Join a room with optional member metadata.
Leave a room.
Signal that a member has started or stopped typing.
Marks a class as a Room handler.
Processes
RoomService annotations.Serialize the
Object that was used as parameter to Broadcaster.broadcast(java.lang.Object).This class is used when the
AtmosphereFramework detect the container
detect Servlet 3.0 Asynch API.A simple Factory to get access to the .
A factory class that can be used to handle the Servlet API internal proxy.
A MethodHandler can be added to allow Frameworks using Atmosphere to customize internal behavior.
Simple
BroadcasterCache that use an HttpSession to cache
messages.An interceptor that create an
HttpSession on the fist received request so transport like long-polling
can share the session with request coming after the suspend operation.Capable of restoring HTTP session timeout to given value.
Allows invalidating and restoring HTTP session timeout.
Simple
Broadcaster implementation that use the calling thread when broadcasting events.Like the
AsynchronousProcessor class, this class is responsible for dispatching WebSocket messages to the
proper WebSocket implementation by wrapping the Websocket message's bytes within
an HttpServletRequest.A simple
Principal backed by a name string.An Atmosphere interceptor to enable a simple rest binding protocol.
A class annotated with this annotation will be instantiated only once.
HTML 5 Server-Sent Events implementation.
Like the
AsynchronousProcessor class, this class is responsible for dispatching WebSocket stream to the
proper WebSocket implementation by wrapping the Websocket message's bytes within
an HttpServletRequest.Adapted from Apache Commons code
Simple Aggregator that aggregate broadcasted String until it reach the
limit.
An interceptor that keep track of
AtmosphereResource.uuid() and disable invocation of AtmosphereResourceEventListenerAdapter.onSuspend(org.atmosphere.cpr.AtmosphereResourceEvent)
and AtmosphereResourceEventListenerAdapter.onPreSuspend(org.atmosphere.cpr.AtmosphereResourceEvent)An
InvocationHandler that delegates method calls to a thread-local instance.Optional SPI for server-side token refresh.
SPI for validating authentication tokens on Atmosphere connections.
The token has expired but was otherwise valid.
The token is invalid (bad signature, malformed, revoked, etc.).
The result of token validation.
The token is valid.
An
AtmosphereInterceptor that adds message size and delimiter, and encodes the message in Base64.A
PerRequestBroadcastFilter implementation that add the expected length of the message.An
AtmosphereInterceptor that add a message size and delimiter.Enhanced type resolution utilities.
An unknown type.
An Unbounded Broadcaster Pool Provider of
BroadcasterUniverse contains static reference to Atmosphere's Factories.
Utils class.
An improved
BroadcasterCache implementation that is based on the unique identifier (UUID) that all
AtmosphereResources have.An annotation to use in order to replace the default
UUIDProviderClass contains information about Atmosphere framework
A non-connection-based room participant — for example, an AI agent, bot,
or server-side service that can receive room messages and respond.
An
AnnotationProcessor that does nothing.An
ExecutorService that does nothing and execute using the calling Thread.Represent a portable WebSocket implementation which can be used to write message.
Manages WebSocket configuration including protocol, processor, and factory settings.
A listener for monitoring what's occurring on a WebSocket, independently of the underlying implementation.
An implementation of
WebSocketEventListener with just log event as trace.A factory for retrieving
WebSocketAn annotation for telling Atmosphere which
WebSocketFactory class to use by default.A very simple interface adapter class that implements all methods and expose a WebSocket API
close to the JavaScript Counterpart.
Simple Adapter for
WebSocketHandlerAn annotation for telling Atmosphere which
WebSocketHandler class to use by default.A Servlet Filter for configuring which WebSocket protocol version an application want to support.
Mark WebSocket Message as suspended.
WebSocket Ping/Pong Listener.
Atmosphere's WebSocket Support implementation.
An exception that can be used to flag problems with the WebSocket processing.
Simple Adapter fpr
WebSocketProcessorFactory for
WebSocketProcessor.An annotation for telling Atmosphere which
WebSocketProcessor class to use by default.A WebSocket based protocol implementation.
An annotation for telling Atmosphere which
WebSocketProtocol class to use by default.A streaming API for WebServer that support WebSocket streaming.
A Streaming Interface for WebSocket.
An Adapter for
WebSocketStreamingHandlerAdapterSimple
BroadcastFilter which automatically filter
HTML/HTTP character into proper value, like \n replace by <br>.
NoOpsRequestdirectly instead.